version 2.20 (20 January 2003)
--------------------------------------------
- Boundary-Control-Entity (BCE) icons added to TGD

- Fixes for compilation under Cygwin

- StateChart Diagram Editor (TSCD)


version 2.10 (16 April 2002; internal)
--------------------------------------------
- Added install flexibility: TCM components may be installed to other directories 
  (not only directly below $TCM_HOME) by setting additional environment variables 
  like $TCM_LIB, $TCM_CONFIG, $TCM_HELP, $TCM_BIN, $TCM_MAN and $TCM_SHARE.

- TCM being added to Debian Linux distribution

- Enhanced updates for gcc3 compatibility.

- Major redesign: Generic Shape Facility (needed for hierarchy)

- Added support for hierarchic diagrams

- Collaboration Diagram Editor (TCBD)

- Optional: add Model Checking to TATD 

- Option to add extra point sizes (see TCM config file)

- Fixes for compilation under BSD (FreeBSD/Mac OS X/Darwin)

- Fixes for gcc3 compatibility.

- TCM being added to SuSE Linux Professional distribution


version 2.01 (12 Februari 2001)
--------------------------------------------

- Fixed some major build errors under RedHat 7.0 
  (Thanks to Gilles J. Seguin and Alan Eldridge)

- Fixed/Cleaned up various Makefiles. (Thanks to Alan Eldridge)

- Added "Open document" option to File menu of TCM startup window,
  allowing to start an editor with the selected document instantly.

- Modified: Using the __GNUC__ definition now to differentiate
  between include files <string.h> and <strings.h>.

- Modified: Liteclue :
  Last field of the XtResource structure is of type (void *).

- Compiled under Solaris with the SUNWspro C++ compiler
  version 5.1. Some little changes in Config.tmpl and some
  source files.


version 2.0 (14 November 2000)
--------------------------------------------

- Modified: In the file format of the UML-editors, all specific
  node-, edge- and shape types get a three-letter prefix
  SSD, UCD, ATD, CPD, DPD (later this convention will be applied to 
  the other editors too).

- Modified: UML editors:
	*Relationship* -> *Association*
	*IsaRelationship* -> *Generalization*
	*TaxonomyJunction* -> *GeneralizationNode*
	*AggregationJunction* -> *AggregationNode*
	*InactiveState* -> *WaitState*

- Modified: UML editors:
  Each node type-name ends on *Node, each edge type-name ends on *Edge

- Modified: TDPD/TCPD: these editors have now their own node and
  edge types instead of GenericNode and GenericEdge. Node-edge
  connections are checked now. Both editors can read a diagram
  made by the other editor.

- Fixed: TDPD/TCPD: it is now possible to add a name to an interface dot.
  
- Modified: Table editors: new dialog windows for update line style and 
  update line width.

- Fixed: TSTD: shape selection and movement did not work correctly
  when the drawing was scaled.

- Added: Optional direction arrows to the name labels of 
  BinaryRelationships in TESD, TSSD, TUCD.

- Modified: StickMan node shape type is resizable.

- Fixed: BuildingBlock and NoteBox are now correctly filled.

- Fixed: Most polygon node shape types have a correctly drawn "dual" 
  line style.

- Modified: Solid{Horizontal,Vertical}Bar have invisible line style.

- Fixed: Line connections with top side of (Sub)Folder, top and bottom
  of Disk, left side of BuildingBlock, diagonal sides of Cube are now
  correct.
 
- Added: to TGD, Cube, Folder, SubFolder and BuildingBlock.
 
- Added: to TGD, vertical scrollbar to Node Icon Tiles frame in order 
  to allow more icons to be added.

- Added: Disk node shape type. Added to TGD.

- Modified: Update Line Ends and Update Line Style is not available anymore
  from a specific diagram editor.

- Fixed: bug in TUCD that made it impossible to add card. constraints and
  role names to relationship edges.

- Added: Email address for statistics and bug-emails is added to tcm.conf.

- Added: Newest version of LiteClue (1.5).

- Fixed: When tables editor read a table then rows and columns stay the
  same size as in the file (before, the rows and columns could be enlarged
  to the 'minimal row/column size').

- Modified: in table editors the 'minimal row/column height/width' is
  changed into 'default row/column height/width'.


version 1.99 (06 June 2000)
--------------------------------------------

- Doc: User Manual is updated till version 1.99.

- Added: A3 page size support (Thanks to Reinhard Max <max@suse.de>).

- Added: Page size and scale value are stored in TCM document files.
  File format is extended (version=1.30).

- Fixed: In TSSD, Aggregations and Compositions were stored in the
  TCM document files are BinaryRelationship. 

- Fixed: Conversion of BlackDot/SolidHorizontalBar/SolidVerticalBar
  into other shape type results into an _unfilled_ shape.

- Added: new options in tcm.conf "SendEmailOnCrash" and "SendEmailOnStartup".
  These are used instead of the compile time options -DBUGREPORT and
  -DANNOUCE.

- Added: Dialog window with icons for converting node shape types in TGD.
  It is possible now too to convert from/to Stickmen. 

- Modified: Icons show document name as icon title (instead of name of the 
  editor).

- Fixed: line-line connections. When a line handle is moved, added or removed
  then the positions of the lines that are connected to that line are
  updated to accommodate to the new situation.

- Added: Command in diagram and table editors to set/unset text underlining.
  This command can be called via Properties->Set/Unset Text Underlining.
  The text underlining of selected shapes/cells will be inverted.

- Fixed: Generalization in TUCD. Was not allowed. 

- Fixed: RoleNames in ParticipantLinks (TESD, TSSD) were not stored 
  as a string (i.e. with double quotes).

- Modified: Always attempt to read in newer file format versions. When it 
  doesn't work you will see what goes wrong in the message log dialog window.


version 1.98 (05 April 2000)
--------------------------------------------

- Some bug fixes to make default load/save files in FileSelectionsDialogs
  in Lesstif working. Also a bug fix to let Find/Replace work under
  Lesstif.

- Some bug fixes and additions to the RPM .spec files.
  Most important that now a non-root user can build RPMs too, by
  using the --buildroot flag.

- Update of the technical documentation (to be found in 
  doc/developersguide/index.html, developersguide-1.98.ps.gz).

- Removed all compile warning generated by the new Sun C++ compiler
  (SUN CC 5.0) and egcs-2.91.66.

- Reorganisation of the online documentation.
	- Latex sources (including bib, style, TCM and EPS files)
	  are no longer part of the source code distribution. They
	  are put in a separate 'docsrc' distribution, that is
	  installed in $TCM_HOME/doc/docsrc/
	- Added to source code dist. a doc/index.html an HTML-index to 
          the various docs.
	- Source code documentation (generated with doc++) can be
	  found in: doc/sourcecode-'version'.ps.gz and
	  doc/sourcecode/index.html (HTML pages).
	- Technical documentation (developer's guide) can be found in:
	  doc/developersguide-'version'.ps.gz and
	  doc/developersguide/index.html (HTML pages)
	- User manual can be found in: 
	  doc/usersguide-'version'.ps.gz and doc/usersguide/index.html
	  (HTML pages).
	- Various specifications for individual editors can be found
	  in:  doc/specifications/ 
	- The wishlist e.a. can be found in:
	  doc/wishlist/FutureDevelopments.html
	  doc/wishlist/WishList.html
	  doc/wishlist/WishListDone.html

- The Makefiles are adapted to the new documentation organisation.
  When you issue 'make clean' in $TCM_HOME all documentation is removed 
  and when you issue 'make docs' in $TCM_HOME then all documentation
  is generated again from their sources (in HTML format, as 
  gzipped-PostScript and (new) in PDF format).

- For making HTML pages of the user's guide and developer's guide the
  external program LaTeX2HTML is used. LaTex2HTML can be found at
  ftp://ftp.tex.ac.uk/tex-archive/support/latex2html.

- For making Latex pages and HTML pages from the C++ source code the
  external program DOC++ is used. The sources of DOC++ are supplied
  with our 'document sources' distribution.

- For making PostScript and PDF from the dvi-files (generated by LaTeX)
  the external programs 'dvips' respectively 'dvipdf' are called.
  
-  Toggle button 'show indexes' is called now 'create/edit indexes'.
   When it is on, new nodes (GenericNodes in TGD, Data- and ControlProcesses 
   in TEFD) get an index-label. This label can be edited when you
   click on it. Also, when this toggle is on, you can add an index to a
   node shape without an index. The 'Renumber Indexes' command only
   works on nodes that have already an index.

- From now on (click or drag with) Shift+Button1 has the same effect 
  as using Button2. This is useful for mice that miss a middle button.
  For users who prefer to use all three buttons, nothing will change.

- From TCM you can generate PNG-files via Print-->Export.
  PNG is a format that is understood by most webbrowsers and by M$
  Word. PNG is similar to the GIF-format but less controversial
  (see http://www.cloanto.com/users/mcb/19950127giflzw.html and
   http://burnallgifs.org).

- Generation of PNG format is done with the fig2dev command that
  processes a temporal .fig file. fig2dev is part of the Transfig
  package that can be downloaded from ftp://www-epb.lbl.gov/xfig.

- -toPNG <file>.png command line option added to all editors.

- Added a new command to resize a (node) shape. It makes a node shape
  larger/smaller by relocating a side or corner on the screen (like
  you do in most window-managers)
  The command is issued when you drag a node handle with Button2 (or
  Shift+Button1). The original resize command that resizes from the 
  center of the node is still functioning in same way (drag with 
  Button1). This new resize command is in particular useful when you 
  need to resize boundary-boxes, subject areas and the like.

- Added command to delete line handles. This will be performed when you 
  click on an intermediate line handle of a single selected line with 
  Button2 (or Shift_Button1).

- Command added to 'Convert From/To Curves' (called via Edit menu).
  This converts selected curves to segmented lines and selected lines
  that have 3 segments to curves.
 
- The system architecture figures of the developer's guide (formerly
  know as the 'techdoc') are updated to the current situation and have
  the TSSD (UML) notation.

- The PrinterName option in tcm.conf has now a higher priority than
  the contents of the PRINTER environment variable.

- Boolean option PrivateColormap is added to tcm.conf. When it is
  True then all editors are started with a private color map.

- New dialog windows for "Update/Default Line Style", "Update/Default
  LineWidth", "Update/Default Text Alignment" and "Align Nodes".
  These dialog windows show the different options as icons. The OK-
  button is called "Apply" and when it is pressed the window is not
  dismissed anymore.

- New command to update the line endings (different kinds of arrows) of
  a line. Via Properties->Update Line Ends you get a dialog window
  where you can choose from the different line endings.
  When you press "Apply" the endings of all selected lines are
  updated. Note that with this command the representation of an edge 
  is changed, the edge will not change type.





version 1.97 (20 February 2000)
--------------------------------------------

- Removed Color-x sources from main distribution.

- Option in tcm.conf file to choose between old and new colors in the  
  TCM GUI. This option can be overridden in your .tcmrc.

- Removed lib/tcm.sys, merged it with lib/tcm.conf

- Building RPMs for Linux.

- Update of the user manual.

- Translation of the wish list into English.

- Bitmaps in line style popup menu of TGD.

version 1.96 (16 January 2000)
--------------------------------------------

- Two new UML editors. TCPD and TDPD (for component and
  deployment diagrams), respectively.

- 'install' tags added to the Makefiles. 'make install'
  installs everything for a binary distribution to TCM_INSTALL_DIR
  (/opt/tcm by default).


version 1.95 (09 January 2000)
--------------------------------------------

- User interface colors and fonts are modified.

- New TCM logo.


version 1.94 (20 December 1999)
--------------------------------------------

- Added first version of TATD (UML Action Diagrams).

- Added scrollbars to the tcm startup window.

- Made distributions ready for spreading via Internet.

- Updated the web pages for new release.

- Changed NoteBoxLink into CommentLink everywhere in the
  sources.

- Added TESD, a subset of TSSD for Entity Relationship
  diagram in the Structured Analysis method.

- TERD is moved to Miscellaneous editors.

- Simplified the Makefiles, different entries for compiling 
  tools are combined into one.


version 1.93 (13 December 1999)
--------------------------------------------

- Added in toplevel Makefile 'make docs' for building the
  user manual, technical documentation and the class documentation
  in one run.

- Compiled and tested TCM with LessTif on RedHat 6.0.

- New layout for the "Line Style" labels in TGD.


version 1.92 (29 November 1999)
--------------------------------------------

- Compiled under Sun CC 5.0.

- User manual is updated.


version 1.91 (25 October 1999)
--------------------------------------------

- Tool for Use Case Diagrams (TUCD) added to TCM.

- TCM compiled under RedHat 6.0. with glibc6 and Motif 2.1.
  (Motif Complete).

- TCM mailing list created (tcm-users@cs.utwente.nl).


version 1.90.0  (12 September 1999)
--------------------------------------------

- Source code documentation can be generated via a Makefile
  by using doc++. The sources of doc++ are included to the
  src distribution.

- Versioning now in the form of 1.x.y.

version 1.89  (28 August 1999)
--------------------------------------------

- Line type added to TGD: line with white triangle line end.

- A bug fix to TSSD for reading in diagrams of version 1.82.


version 1.88  (18 August 1999)
--------------------------------------------

- TSSD: show/hide stereotypes and show/hide properties are now 
  undo-able commands that work on the current selection.

- TSSD: added SSDParticipantLink edge type (represented by a SSDRCLine)
  for connecting class or object nodes with N-ary relationship nodes. 
  A participant link has a role name and a cardinality constraint
  label. Other possibilities for connecting these two nodes are not 
  allowed.

- TSSD: renamed SSDBox -> SSDSingleClassBox, SSDObjectClassBox ->
  SSDSingleObjectBox, SSDObjectDoubleClassBox -> SSDDoubleObjectBox.

- TEFD: in an event flow is allowed as label:
  E/D and T for data process -> data process.
  E/D       for external entity -> data process.
  'every text' for control process -> data process.

- Changed BinaryAssociation into BinaryRelationship in the TSSD
  file format.

- TSSD: Objects can be connected in an n-ary link (connected to
  a n-ary relationship node).

- TSSD: NoteBoxLink implemented as a separate edge type (instead
  of an EmptyEdge).

- Added NoteBox to TGD.

- Renamed BlackDotEllipse to BullsEye.

- Removed bug that caused that in PostScript and Fig fill node shapes with
  invisible line style were not displayed.

- Removed a bug that gave errors with the cut-paste bugger after a New.

- Removed some memory leaks.


version 1.87  (5 August 1999)
--------------------------------------------

- Implemented VerticalBar and added it to TGD.

- TERD/TCRD/TSSD: Name changes: 
	Relationship->RelationshipNode
	*ObjectClass/*ObjectType->*ClassNode
	Action->Operation
	*Path->*Link
	(file format changed too but old diagrams are still read).


version 1.86  (2 August 1999)
--------------------------------------------

- Implemented fill node. Colors are chosen from color chooser dialog.
  Extra option to make nodes unfilled (transparent).

- TCM uses only $TCM_HOME/lib/colorrgb.txt for the colors. In principle
  you can now add your own color definitions to that file.


version 1.85  (9 July 1999)
--------------------------------------------

- Option in table editor to print/export row and column numbers.

- Possibility to move the selection in the table editors by
  using the arrow keys.

- For going into edit mode in table editors it is not necessary
  to move the mouse pointer into the cell. You only have to make
  sure a single cell is selected and then you can simply enter
  characters.

- In the table editors the row and column labels are duplicated
  at the right- respectively bottom-side of the table.

version 1.84  (28 June 1999)
--------------------------------------------

- Added GNU copyright notices.

- Bug removed: a Paste after a Load or New in a diagram editor
  resulted into a crash.

- TSSD: Object Nodes and Object Links implemented.

- TSSD: Object nodes have underlined names.

- Each text shape and cell text has an extra attribute "underlined"
  that indicates whether the text is underlined or not. The diagram
  editor text field contains an new boolean "NameUnderlined" field.

- Bug removed: after cardinality constraint garbage text could
  be added.

- TSSD: BinaryRelationship renamed to BinaryAssociation.
	AssociationPath renamed to AssociationLink

- TSSD: Relationship node renamed to N-ary assocation.

- TSSD: is_a arrow changed into UML type generalization arrow
  (white triangle as arrow head).

- Startup window is updated with buttons for all future
  UML editors. Also, the editors are grouped by: Generic, Structured
  Analysis (SA), UML and Miscellaneous. To each startup-button
  is a bubble-help text attached shortly describing the editor.


version 1.83  (11 June 1999)
--------------------------------------------

- Update Line Color and Update Text Color implemented.

- Implemented color preview in color chooser dialog.


version 1.82  (27 April 1999)
--------------------------------------------

- Implemented color chooser dialog window.

version 1.81  (20 April 1999)
--------------------------------------------

- Implemented default line color and default text color.

- Implemented "line ends". Every line has two line ends
  that can be OpenArrow, WhiteCircle, BlackTriangle etc.
  These line ends make specific Arrow classes unnecessary.
  The file format is adapted to store the line end values
  of each line.

- Implemented SolidHorizontalBar and SolidVerticalBar in TGD.

- Implemented Stereotypes and Properties in TSSD (was USSD).

- Implemented Update Node Shape Type command in TGD to
  convert between different node shape types.

version 1.80  (15 April 1999)
--------------------------------------------

- Generation of Fig format completed.

- In Fig generation you can choose between normal (PostScript)
  fonts and LaTeX fonts.

- Implemented "-toFig" command line option to generate Fig
  format.

- Updated the color list in lib/colorrgb.txt.


Version 1.7.9. (05 March 1999).
--------------------------------------------

- EllipsedBox node shape type added to TGD.

- WideDotted line style used in USSD (for association path).

- Removed some bugs in resizing NoteBox and RoundedBox.

- After Check Document in table editors, cells with errors
  are selected.

Version 1.7.8. (01 March 1999).
--------------------------------------------

- First version of FigGrafport implemented for generating
  Xfig format from TCM documents.

- Removed some bugs regarding loading file format of TERD,
  TRPG and TSND.

- Removed bug from TDFD: Data flows were drawn without arrow.

- Tables are loaded more efficiently. They are not redrawn
  many times unnecessarily.

- Lines with multiple text shapes (for instance ER lines
  with cardinality constraints and role names): empty text
  shapes can be selected more easily.

- Check Diagram: every node or edge that contains an error
  will be selected.

Version 1.7.7. (23 January 1999).
--------------------------------------------

- -toPS and -toEPS options for generating PostScript and EPS from
  the command line.

- command line options revisited. See -h command line option.

- bug removed: file names with illegal chars (spaces, '/' etc) are now not 
  accepted anymore in SaveAs.

- added flex/bison mini-parsers to CX-tools.

- some extensions to USSD (actions).

- added windex file to man directory. Used for man -k.

- fonts in GUI are made larger (10->12).

- Xresources file in lib/ is renamed to TCM.


Version 1.7.6. (6 January 1999).
--------------------------------------------

- Some modifications needed for porting to HPUX and OSF1.

- Some extensions to USSD.

- Bugs removed in "change box type" and "copy hexagon".

Version 1.7.5. (4 January 1999).
--------------------------------------------

- Added first version of USSD (UML Static Structure Diagram)
  editor.

- "Porting" for usage with LessTif under Linux.

- Each line has two "end-types" as attribute. These types can
  be empty, arrow head, double arrow head etc.

- Arrow shape types removed.

- Save page info to file.

- Some extra comments in saved file.

- In TGD: edges can be connected to edges, lines to lines.

- Operations/algorithms adapted to fact that edges can
  connect to edges.

- Header&Footer as doc info (page menu).

- Bugs from cut/paste buffer removed.


Version 1.7.4. (19 November 1998).
--------------------------------------------

- Changed e-mail address, ftp site, www site from VU into
  UTWENTE.

- Updated lib/help files to current situation.

- Updated README and COPYRIGHT to current situation.

- File format changed: for each Shape the boolean attribute 
  FixedName is written.

- TDFD: index numbers beginning with 0 (except a single 0)
  are not allowed anymore.

- Specific table editor options in config file (FETcolumnWidth,
  TUTcolumnWidth, TUTnumberOfColumns, TableTopLeft).
  NumberOfCopies option is removed.

- Made the tools resistant to dubious values in the config file,
  like ColumnWidth=-10 and GridSize=0 etc.

- Removed some bugs concerning adding and moving edge handles
  and redirecting edges to different nodes.


Version 1.7.3. (03 November 1998).
--------------------------------------------

- CRUD string test added in Check Diagram of TFET.

- Table editor options in tcm.conf. Table Editors and the TCM startup 
  tool read their initial values from tcm.conf.

- Default LineStyle and LineWidth in tcm.conf.

- All update line style operations are called from a 
  popup window (instead of many different menu options).

- Implemented update line style command (called from Properties
  menu). Pops up a specific dialog window. You can choose
  between Solid, Dashed, Dotted, Dual and Invisible line
  style. When you press OK the line styles of the selected
  shapes are changed to that line style.

- Implemented a font chooser dialog window. This is shown
  when the Update font or Default font commands are issued
  from the Properties menu. You can choose an arbitrary
  combination of Font family, Font style and Point size.
  In the dialog there is a preview text string displayed
  in the chosen font.

- Default font is set now via the font chooser dialog.
  All those submenus are not necessary anymore.

- Removed bug about font names that could not be loaded
  and made the editors crash.

- TGD: indexes are numbered consecutively and black dots
  cannot get an index. A new node class EmptyNode is added
  to TGD for nodes that cannot have an index and name 
  (represented by a black dot or a circle with a black dot).

- Reindex command added to all editors that have node
  indexes (such as TGD).

- Improved the distribution of multiple lines between the
  same pair of nodes.

- TERD/TCRD: removed a bug that made it impossible to edit 
  taxonomy junctions.

- Scaler::SetNormalScale does nothing when it is in normal
  scale already.

- The commands DragShape, DragShapes, DragTextShape and
  DragHandle do not commit when the distance is zero.

- Improved the layout of the tiled buttons in the diagram
  windows so that every button is visible in the most 
  common display sizes.

- Tree editors: in the tree mode all commands that cannot
  be committed are made grey (insensitive) menu items.

- Annotate Document entry is moved to the Document menu.

- In the generic editors the Check Document menu item is
  not available anymore.


Version 1.7.2. (26 October 1998).
--------------------------------------------

- Removed a bug that made the table editors crash after an Undo.


Version 1.7.1. (24 September 1998).
--------------------------------------------

- Added new command to add edge handles. Drag a handle
  with button-2 to add another handle (drag with button-1
  moves a handle, like it did before).

- Simplification of config files in $TCM_HOME/lib. 
  They do not contain version numbers and sections anymore,
  but only attribute-value pairs and comment.
  There are three config files:
  1. $TCM_HOME/lib/tcm.conf contains all general TCM options.
  2. $TCM_HOME/lib/tcm.sys contains a few platform specific
     TCM options. Options in 2. override/extend those in 1.
  3. (optionally) $HOME/.tcmrc contains some user specific 
     TCM options. Options in 3. override those in 1. and 2.

- Check diagram functions revisited. Many specific diagram
  checks are made more generic and added to the DiagramChecks
  class in libdiagram. Error messages should be clearer.
  Classes RPChecks and TRChecks are deleted.

- The line style of the separator lines in DoubleBox and
  TripleBox can be changed programmatically.

- Improvement in text editing inside nodes that are filled
  with a color.

- Compiled under Solaris with the newest SUNWspro C++ compiler
  version 4.2. Some little changes in Config.tmpl and some
  source files.


Version 1.7.0. (September 1998).
--------------------------------------------

- Removed all code of TSOD from the TCM distribution.

- Made two new editors for the Color-X project.
  csod (Color-X static object diagram) and ced
  (Color-X event diagrams). The specific code
  is in directory cx. These tools have an interface
  with the WordNet 1.6 program. These tools make use
  of the TCM libs but are not really part of TCM.

- Updated the file format (version 1.22). Old file 
  formats are still accepted however. See user manual,
  appendix B.

- Added two option menus to TGD that determines whether
  a new node or edge is drawn solid, dashed of dotted.

- Each node can have an index number label. These labels
  can be shown in tdfd, tdefd, and tgd. There is a
  toggle beneath the node icon list that indicates
  whether indexes are shown or not. Index labels can be
  edited separately from the name label.

- Text menu is renamed to Properties. Find/Replace are
  put in a new Menu named Search.

- Properties has a distinct sub-menu for default properties.

- Properties include the default line width and the
  update line width command.

- The Grid menu is made part of the View menu.

- Added some extra node shape types to TGD, like
  HorizontalBar and Hexagon.

- Each table cell can have a distinct annotation text.
  Cell annotations are added to the table file format.

- Table line styles are the same as shape line style of the
  diagram editors. "Fat" line style is removed from the table
  editors (you have to use update line width to make lines fat).

- Update line width/default line width commands in 
  diagram editors in Properties Menu.

- Update line width/default line width commands in 
  table editor (update line width is not fully implemented yet).

Implementation:

- All DashedXXX classes, Dot, All PredefinedXXX classes,
  TCircle, TextShapeXXX classes are removed.

- Reimplemented textshapes. All specific textshape
  classes are removed. Instead one single textshape
  class is used. The specific diagram classes determine
  the relationship between textshapes, shapes and subjects.

- Bitmaps (icons) have new, more logical, names.

- toolkit.c and code.c are moved to libglobal.
  libglobal is the only library that has to be changed when 
  new editors or shapes are added to the toolkit.

- Updated the shape, node and edge codes, names and 
  classes. Spurious ones like all DashedXXX shape types
  are removed and others have now more logical names (well, at least
  less unlogical).

- The tool (TCRD) specific shape types DoubleBox and
  TripleBox are made tool independent and added to
  libdiagram. These classes are reused in the Color-X tools too.

- All 'predefined' shape classes deleted. Instead,
  a GShape attribute 'fixedName' is used. When a GShape as a
  fixedName the name cannot be changed after its creation.

- Each nodeshape has an extra index textshape as label
  (that can be made visible and/or edited in some of
  the tools).

- Added generic line classes that show 1,2 or 4 extra
  labels, named T1Line, T2Line and T4Line. These classes
  have attributes that indicate where the labels should be
  positioned by default. There is also a T1Arrow.
  Diverse specific line classes in TERD, TCRD, TSND and CSOD
  are all specializations of these abstract line classes.

- TSTD's ArrowBox is renamed to InitialStateBox, HLineArrow 
  is renamed to TransitionArrow. TPSD's URBox is renamed
  to URLabeledBox. LLCircle is renamed to LeftLineCircle.
  C2Line is renamed to C2R2Line.

- Implemented a new shape in libdiagram: BlackDotEllipse
  (an ellipse with a black dot in it). Used in TGD and CED. 

- Implemented a new line class in libdiagram: FlashArrow
  (an arrow with a flash in its tail). Used in CED.

- Changed the colors and fonts in the user interface.
  In particular fonts are made a bit smaller and less colors
  are used.

- All specific table editor code in a distinct directory
  called 'st' (specific table). This is consistent with the
  'sd' directory of diagram editors.

- Updated and simplified the various (platform/compiler
  specific) Makefiles.


Version 1.67 (8 jan 1998).
--------------------------------------------

- Changed file format: Each shape has a Color (see 
  $TCM_HOME/lib/colorrgb.txt), a Line Width (1,2,3...),
  a Line Style (Solid, Dashed, Dotted, Invisible) and
  a Text Color. Each node shape has additionally a 
  fill style (Filled, Unfilled and GrayFilled) and
  a Fill Color. These attributes are read from the file
  but they cannot be changed via the user interface yet.

- Renamed Zoom to Scale everywhere. 

- Extra text field next to the document name showing
  the current diagram level index.

Version 1.66 (27 Nov 1997).
--------------------------------------------

- Changed Postscript that is generated: the original PS became
  too complex for certain PS viewers and printers.

- Bug fix: redo of update text is not always possible but should
  not result into a call to Command::Abort.

Version 1.65 (25 Nov 1997).
--------------------------------------------

- Compilations made for some other platforms (Linux, SunOS, Solaris,
  IRIX, HP-UX). Adaptations to make files and all small compilation 
  errors and warnings were removed.

- Bug fix: crashed when diagram part was pasted and then some
  text in it was edited.

- Bug fix: edge labels were put back into their default positions
  when you read in a file.

- Bug fix: crash after cutting empty text in a table editor.

- Bug fix: when compiled by gcc 2.7.2.2 some menu entries disappeared.

Version 1.64 (7 Nov 1997).
--------------------------------------------

- Bug fix: crash when an non-existent file name was given as command
  line argument.

- Bug fix: when log message could not be delivered, tcm hanged.
  

- Bug fix: crash when New was issued in a diagram editor.

- User manual made up to date.
  

Version 1.63 (3 Nov 1997).
--------------------------------------------

- Paste cell texts modified: the operation did not look at the text sizes
  in comparison with the cell sizes for where the texts are pasted but
  it looks at the relative row and column positions. Only the top-left cell
  where the box is released determines in which cells will be pasted.

- Separated undo and redo into two different edit menu items.
  Undo has accelerator Ctrl+U, Redo has accelerator Ctrl+R.
  Refresh gets accelerator Ctrl+V.

- Implemented multi-level undo and redo. The last couple of hundred
  commands are saved. After a load or new these commands are deleted
  but all the other commands that change something in the graph or 
  layout have an undo/redo.

- Rewrote the whole tree of Makefiles of the source distribution.
  It should be a bit more flexible and easier to understand and maintain
  for people who are not me ;-)

- 1.36 is now ported to HP-UX.
  Thanks to R.J.J. Jongschaap <rob@uttnr10.tn.utwente.nl>.

- Added some modifications to sources and Makefiles for compiling TCM under
  HP-UX 10.x.

- Updates of README.TCM, TCM.LSM.

- Updates of the user manual and the on-line help pages for 1.6.?

- The TCM version number is written as a string to file instead
  of a float. Some buggy Linux libs gave problems with that.

Version 1.62 (24 oct 1997).
--------------------------------------------

- You can not change the tree view mode anymore in the tree editors while 
  you are busy pasting or creating an edge.

- Bug fixed: When an error was found in a file, an incorrect line number
  was mentioned in the error message.

- Added extra checks when a file is read which contains wrong references.
  It notices shapes without or illegally typed subjects, nodes and edges
  without representation, edges connecting not existing nodes, lines connecting
  non-existent node shapes. When this happens, error messages are given 
  and it is tried to end up with a consistent document.

- Improvement to the generated PostScript code. By adding a procedure in
  the PostScript output the PS files become a lot smaller when it contains
  more than one page.

- Bug fixed: constraints on double edge names were not checked
  properly when edge was redirected.

- Manual (Unix man) pages updated for the current 1.6.x version.

Version 1.61 (21 Oct 1997).
--------------------------------------------

- TCRD: soft constraints added: check that an object class is not
  specialized into a relationship class. Check that when a rel. class
  is specialized, the specialization class does not have additional
  components.

- TSTD: an event label string is allowed to contain more than one line.

- Table editors: append table has an undo/redo by now.

- Table editors: the append table FSB has an option menu indicating
  whether the table has to be appended to the bottom or to the right
  of the table (instead of that extra dialog box).

- "Save selection" added to all editors. In the diagram editors it
  saves the selected part of the diagram to file. In the table editors
  it saves the rows and columns which contain selected cells.

- Added accelerators for cut, copy and paste cell text. Append has
  now Ctrl-A as accelerator instead of Annotate subject.

Version 1.60 (17 Oct 1997).
--------------------------------------------

- Soft constraint on ER diagrams: relationship node name + component
  types should be unique.

- Some improvements of the error messages produced by check document.

- TSTD: transitions from and to the same node should contain an action.

- TSTD: fixed: after moving event/actions to another line segment 
  they were not properly redrawn.

- TDFD/TDEFD: added a toggle button to show process indexes or not.
  When show indexes is off: process indexes can not be edited.
  When show indexes is on: process indexes can not be empty.

- Limited the number of possible error messages produced by replace all
  to one.

- TDFD/TDEFD: Added again the text field to set the diagram level and
  which acts as the process index prefix of new processes.

- You can only get into edit mode when you type a _printable_ char.

- Adapted main window sizes and the widget layout to the screen size.
  All tools look correctly on screen as small as 800x600.

- Completed the online help window texts.

- TCRD: removed a problem that caused assertion failed messages while
  editing class boxes.

- TCRD: When auto-resize was off, the labels of class boxes were not
  properly aligned. This fixed now.

- When segmented or curved edges are added or deleted then the labels
  of the other edges do not jump back to their default positions.

- Center diagram and center table command also work correctly when 
  the document is zoomed.

- Check added on document names: they should not contain unprintable 
  characters, white space characters, '{', '}' and '/'.

- Table row and column labels are now all drawn in the default font.

- When the directory text field is updated then the directory of the
  export file selection dialog is updated as well.

- TPSD: everywhere 'order' is replaced with 'sequence'.

- Made the arrow heads symmetric.

- TSTD: Added the immed. constraint that from and to the same pair
  of nodes there should not be two transitions with the same event label.

- Tree editors: while appending a tree you can not change the tree mode.

- The name of the document or subject that is annotated is filled in in
  the annotation edit window.

- Added point size 6 to all editors.

- When the document is too large for the drawing area when the drawing area
  has reached its max. size, an error message is given.

- In Linux the gray fill style (for selection handles) became a black fill 
  style. This is fixed by now.

- Some more improvements and fixes with the checks or error messages 
  of check document. They were all checked against the checks that were
  formulated in the user's guide.

- Fixed: when a document was started with a relative path name, the 
  directory part was not removed from the file name in the document 
  name.


Version 1.59 (1 Oct 1997).
--------------------------------------------

- Possibility to type in ISO-Latin1 characters in in-line editor.

- 8 bit characters are written to PostScript in ASCII format 
  (octal notation).

- Generated PostScript shows all ISO-Latin1 characters correctly.

- Outline editor size is maintained correctly. When you resize
  the edit window the size remains the same when you pop up the 
  window again.

- When an edge is redirected all relevant edge constraints are checked.

- In TCRD the soft constraints regarding unnamed (component)functions
  are improved.

- Bug removed: when the main window was deleted (not destroyed) then
  the editor continued to run and crashed.

- The TCM icon is now visible in all window managers that
  I know of including olwm.

- The length of text strings in generated Postscript is made unlimited.

- Some small simplifications in the generated PostScript.

- Bug removed from Tree editor. Cut operation led to a crash.


Version 1.58 (26 Sep 1997).
--------------------------------------------

- Bug fix: editor crashed when you Quit and you were still in
  edit mode.


Version 1.57 (16 Sep 1997).
--------------------------------------------

- Bug fixed regarding double ids in a TCM file. Now correct error message
  and editor does not crash.

- Bug fix regarding transition label editing in TSTD.


Version 1.56 (7 Sep 1997).
--------------------------------------------

- Some bug fixes, amongst others in constraint checking
  and regarding drawing certain special shapes.

- Bug fix: some message dialogs made TCM for Linux crash.


Version 1.55 (31 Aug 1997).
--------------------------------------------

- Implemented Undo for Update font, update text alignment,
  update row and column alignment and for update line style.

- Implemented Undo for change box type.
  Change box type is an edit menu command.


Version 1.54 (20 Aug 1997).
--------------------------------------------

- Removed all X/Motif specific code from non libgui classes,
  except the classes *window.[hc] and *stubs[hc].
  Easier to port and maintain?

- The code from sd/ is split into 5 parts (data view (dv), behavior view
  (bv), function view (fv), generic diagram (gd) and tree (tr).

- Makefiles for the different platforms are improved.

- Started with implementation of multiple shape views. Shape views are
  written to file and read according to the file format of TCM2
  (however the are not yet user operations on multiple views).

- Extensive internal consistency checking when a diagram is read.


Version 1.53 (15 aug 1997).
--------------------------------------------

- Deleted some bugs in TSTD that produced crashes when transition labels
  were moved.

- A different arrow head shape is drawn.


Version 1.52 (28 HJul 1997).
--------------------------------------------

- When a dialog is popped up, it will be displayed near the current
  mouse position.

- Ported TCM to AIX.

- Implemented find/replace/find-all/replace-all in both 
  diagram as table editors including undo/redo, case sensitive,
  substring and name only finding and replacing.

- Put every class in a separate file (file name = 
  class name (in lower case letters)). Almost like TCMJava.
  
- Implemented bubble help with lite clue.

- Removed bug which caused a crash after DuplicateCmd->Abort.
  (same as Wouter Wijngaards reported ?).

- Removed bugs that limited text sizes in drawing area to
  MAXNAME chars.

- Removed bugs that caused crashes with undo/redo after
  editing text in a class box/transition arrow.

- After an abort of a command undo/redo of that command
  is not possible anymore.

- Inconsistent graphs: for some reason they sometimes occur:
  but now some extra assertions are added and the inconsistent parts
  are not written to file anymore.

- Rewrote the code from intersect.h, link.h, key.h, setval.h
  into C++ classes.

- Removed spurious comments for doc++ from the header files.

- After a crash mail is sent automatically to tcm@cs.vu.nl.

- Tested extensively with purify. Removed all memory leaks
  that were found.

- And a zillion of other changes and bug fixes....


Version 1.51 (17 jul 1997).
--------------------------------------------

- Main window layout, colors, new T(ea)pot icon.

- Moved most X/motif code to separate directory/library
  libgui.so (the remainder is in specific ??Window classes
  in the other libraries).

- Implemented a lot of special dialog classes.

- Text viewer dialog class contains a SaveAs, Print, 
  Copy and Find operation.

- Text edit dialog class contains a Load, SaveAs, Print, 
  Cut, Copy, Paste, Delete, Find and Replace operation.

- Document and subject annotations can be edited with a
  text edit dialog.

- Online help is extended.

- Save PostScript commands replaced by single Export 
  dialog box, to be used for different output formats.

- In TDFD and TDEFD you can edit Minispecs.

- In TDFD and TDEFD you can say that a process is
  contiblabla/instanblabla. And you can give it's activation
  mechanism.

- During a drag operation in editor (with left mouse button)
  you can always abort (with middle mouse button).

- The last visited directory in the Load/Save To File dialog
  box becomes the current directory and vice versa.

- File format of TERD, TCRD, TDFD, TDEFD and TSTD is changed
  so that it complies to the new TCM2 file format.


Version 1.3.6.   (30 mar 1997).
--------------------------------------------

- Some memory leaks removed.

- Bug removed from "undo duplicate".

- Extra assertions put into diagram editor code.

- Regeneration of source code documentation with doc++.

- Some bug fixes concerning DFD indexes.


Version 1.3.5.   (22 mar 1997).
--------------------------------------------

-  Small changes in main window layout for fitting all buttons also in
   smaller screen sizes.

-  TCM will not be started anymore when TCM_HOME is not set.

-  Some bugs removed concerning creating and deleting duplicates.

-  Some bugs removed concerning pasting parts of diagrams.


Version 1.3.4.   (15 mar 1997).
--------------------------------------------

-  Removed a bug in the tree editors which caused a crash when a tree
   is saved.

-  In the data flow editors the index number is now called 'counter' and
   the level field is called 'diagram'.

-  TDFD: implemented a re-index command, issued via a button near the DFD
   counter which gives each process defined on the current diagram
   a new unique index from one to the number of these processes.
   The re-index command has an undo.

-  In the data flow editors the index number text field is not user
   setable but completely automatic. It always displays the _next_ unused 
   free index number for the current level. When the user creates a new 
   process, the new process receives this index number. When processes are 
   created or deleted the index field is updated, if necessary. Also, when 
   processes are copied and pasted or when a diagram is appended the new 
   processes always receive a unique index number. Duplicates have the same
   index number as they represent the same process. If the user wishes, he 
   can can still edit the index label by hand.

-  Implemented scalable X fonts. When a document is zoomed in or out
   the font is scaled proportionally. In the config file there is
   an option to turn off scalable X fonts.

-  Moving a diagram with the arrow buttons to the left or top border of 
   the drawing area is improved. When the diagram arrives at the border 
   it will not be corrupted as it was before.

-  The undo of drag shapes and the center operation was faulty when applied
   to segmented lines: the handles were not repositioned at their
   original places. This is fixed by now.

-  When a document file contains a document name that differs from
   the file name, a pop-up dialog is posted when that document is
   being loaded, asking whether you want to have the original document 
   name or the file name as new document name.

-  Improved the page sizes: Us-letter was a non-existent or at least a 
   very unusual page size. There are now four possible standard page sizes:
   A4 (default), Letter, Legal or Executive (they have the sizes as
   in ghostview).

-  When the page size is changed, a refresh is done.

-  When trying to quit and the user tried to save the document to
   an unwritable directory, the error dialog was covered by a
   quit confirmation message dialog. This is fixed: the quit dialog
   is not posted when the document could not be saved.

-  Added an extra confirmation to the delete all commands.

-  In TCM config files and TCM document files, comment text is accepted.
   Comment is text that starts with a '#' and ends by a newline and
   that is not part of a string.

-  The default system config file $TCM_HOME/lib/tcm.conf is extended
   with comments for the benefit of users who want to modify it.

-  In the config file a version number is stored. A warning is given
   when a version number is found that is older or newer than
   expected by TCM.

-  Added extra constraint to TPSD and the tree editors: you can't
   connect a node by itself.


Version 1.3.3.   (06 mar 1997).
--------------------------------------------

-  Compiled under IRIX 5.3. Adapted make files and made some small
   changes to the code.


Version 1.3.2.   (05 mar 1997).
--------------------------------------------

-  Changed the usage of identifiers in document files. When a document
   is read the identifiers are not changed. I.e. the identifiers in 
   the file become the internal identifiers and vice versa.

-  Some small bug fixes and recompiled for all platforms (Linux,
   Solaris and SunOS). Adapted README.TCM, man pages, config files,
   CHANGELOG and web pages. New distributions are made for ftp.


Version 1.3.1.   (28 feb 1997).
--------------------------------------------

-  TSTD: added decision point node class and added some relevant
   constraints.

-  Made hexagon shape class. This shape type is used to draw 
   decision points.

-  Each editor now shows the current TCM version in the title bar.

-  Removed bug in TCRD which sometimes caused a too large class box 
   and an implementation error message after you changed the cursor 
   position during editing.

-  TSTD: each node has to be mutually unique named.

-  TPSD: the node 'Process' is now internally called 'PSProcess' 
   with is more consistent with SNProcess, DataProcess etc.

-  TSTD: the file format is changed. In the prior version both the 
   coordinates of the separator lines were stored. Now the following
   is stored: a single point (the 'anchor') the number of the line segment 
   the separator belongs to and the relative position of the separator
   (left, right, up or down). This eliminates the bug that after 
   loading a STD the labels can not be properly moved.
   The coordinates of the separator line of an initial state are also
   not stored but recalculated after loading in. The old format is
   still accepted of course.
 
-  Added a system config file in $TCM_HOME/lib/tcm.conf containing
   configuration options for some editor options, like the name
   of the printer, the command to print a file, the page size etc.
   This file is read in by each editor upon startup. The menu items
   of the editor are initialized with the values from the config file.
   The syntax of the file is reminiscent of the syntax of the 
   TCM document files, except that the fields in a certain section
   may be in arbitrary order (or may be omitted). The system config
   file can be copied to and overridden by a user config file to be
   installed in $HOME/.tcmrc. When the config file cannot be read 
   or the contents misses certain options, an error message is printed
   and built-in defaults are used (like in the prior versions of TCM).

-  The minimal row width and column height operations in the table
   editors automatically apply auto-resizing when the auto-resize toggle
   is on and these sizes are made smaller.

-  Accelerators Ctrl-I and Ctrl-O for fast zooming in and out.

-  Find operation (Ctrl-F) implemented for diagram editors. All shapes
   having a certain substring in their names are selected. Find is case
   insensitive. The status line tells how many shapes are found.

-  Find operation (Ctrl-F) implemented for table editors. All cells
   having a certain string as substring are selected. Find is case 
   insensitive. The status line tells how many cells are found.
   
-  Duplicate shapes receive a visual mark (asterisk) showing that 
   we have to do with duplicates. The asterisk is displayed near the
   top left corner of the node shape.
 
-  When you delete duplicate shapes then a question dialog is raised
   asking whether you want to delete only the selected shapes or the
   entire subject (and consequently all the duplicate shapes).
 
-  Create duplicate is now simply called Duplicate. The delete 
   duplicate command is removed from the edit men,  because its function 
   is now superseded by the Delete command.

-  The cut command does not delete all duplicates of the selected
   shapes anymore, only the shapes that are really selected.

 
Version 1.3.0.   (17 feb 1997).
--------------------------------------------
 
- Added: an undo/redo for the text edit operation, both in-line and
  outline. I.e. stop editing is now an undo-able command.

- Added: the undo menu item shows which command can be undone or
  redone.

- Fixed: a bug which caused that the in-line edit cursor sometimes 
  remained visible on the drawing area.
 
- Fixed: outline editing the label of a deleted shape caused a crash.
 
- Undo for move/center document operations (i.e. the operations with
  the arrow buttons). The center operation now works correctly when the
  document is zoomed in or out.
 
- TSTD: improved some of the edit-ability and move-ability of the 
  labels and separator lines of diagonal and curved transition arrows. 
  The movement of the separator line has an undo.


Version 1.2.9.   (11 feb 1997).
--------------------------------------------

- Added continuous event flows and event stores to TDEFD.

- Changed indexing of data and control processes: newly created processes 
  receive the lowest free index number at the current level.

- Change shape selection mechanism: if a _selected_ shape is clicked with
  button1 and the selection contains more than one shape, this shape becomes 
  the first shape of the selection. Empty the selection by clicking
  button2 in the background.


Version 1.2.8.   (10 Feb 1997).
--------------------------------------------

- Added double headed arrows to TGD.

- Compiled under Linux 2.0.18 ELF with gcc 2.7.2. Some code
  changes because of gcc compiler errors and warnings. 

- Fixed: Menu accelerators now work under Linux.

- Fixed: bug in table editors, which caused that the column alignment
  was not applied properly when a table was loaded.

- TFDT (tool for function decomposition trees) becomes
  TFRT (tool for function refinement trees) and TDCFD (tool for data and 
  control flow diagrams) becomes TDEFD (tool for data and event flow 
  diagrams).

- Fixed: in TFET you were asked whether you want to save an _unmodified_
  table when you wanted to quit the editor.

- Added: Tables of one document type can be read by table editors of another
  document type. A warning is given but the tables are converted automatically.
  Ditto for the two tree editors and in TDEFD you can read diagrams made by
  TDFD.

- Data transformation is renamed to data process in TDFD and TDEFD.

- Rewrote a lot of the sources so that no global variables are needed anymore
  and that virtually all code is now part of some C++ class. 

- Rewrote the menu building part of the source to make menu configuration
  a lot more flexible.

- Wrote a special Config class for TCM configuration.

- Wrote new classes for TCM file I/O.

- Reorganized part of the libraries so that a library only contains code 
  that really belongs in that library.


Version 1.2.7.   (06 Nov 1996).
--------------------------------------------

- Fixed: TCM complained when the parent of the project directory
  was unreadable and the directory was set wrongly.

- Fixed: a small bug in the fork drawing in the tree editors.


Version 1.2.6.   (21 Oct 1996).
--------------------------------------------

- Fixed: when the main window is destroyed, TCM will be killed.
  (In earlier versions TCM continued running but without window,
   so the process had to be killed explicitly).

- Added: when lpq is not found on Solaris, the program lpstat
  is used to show the printer queue.

- Added: Redirection of an edge to another node. When the
  handle of an end point of an edge is dragged into a different
  node, the edge will be redirected to that node.

- Added: diamond and dashed diamond shape types to TGD.

- The texts in some popup dialogs are updated.


Version 1.2.5.   (3 Oct 1996).
--------------------------------------------

- File selectors that let you save to a file will always show a 
  default file in the selection field.

- Table editors: auto resize can now make a cell wider and less 
  high or less wide and higher at the same time.

- Fixed: after append diagram the paste box remained visible.

- Table editors: editor settings like DefaultRowAlignment,
  DefaultColumnAlignment, MinimalRowHeight, MinimalColumnWidth,
  DefaultLineStyle, DefaultNumberOfRows and DefaultNumberOfColumns
  are NOT written to file anymore. Instead they are purely settings
  of the editor, not attributes of a table document. Files of an
  older format are still being read of course.

- Table editors: modified is only set to true when the table itself
  is changed, not when an editor option like DefaultRowAlignment
  is changed.

- Man pages adapted to the options of v1.2.5.

- Usage texts (-help option) are made up to date.


Version 1.2.4.   (27 Sep 1996).
--------------------------------------------

- TERD/TCRD: one-one relationship represented by a double arrow.
  (the subject is a Function with card. constraint 1).

- Rounded box shape type is implemented (X, PostScript).
  This is added as a new shape type in TGD.

- TRPG: nodes can be labeled. Labeled nodes are represented by
  a rounded box shape type.

- Table editors: 'stippled' line style is now renamed to 'dotted'.

- Fixed in table editor: default alignments of loaded
  table were set wrongly, this is fixed.

- Fixed in table editor: insertion of > 1 rows/columns in middle
  of table resulted into wrongly positioned row/column labels.

- Fixed: remove from printer queue didn't work.

- Fixed: multi-segmented lines gave pixel droppings.


Version 1.2.3.   (Sep 5 1996).
--------------------------------------------

- lpq, lprm and ghostview commands can be set with a pop-up dialog 
  via the printer options sub-menu (cf. print command).

- Some bug fixes, amongst others: save text before saving to file.

- Cardinality constraints may also be specified in the form of 0,n.
  

Version 1.2.2.   (Aug 25 1996)
--------------------------------------------

New functions:

- (Project) directory can be chosen in startup program (via File->Project
  Directory). All editors will start having this proj.dir. as current directory.
  Editors have a new command line argument -projdir <dir>.

- -drawing 'width'x'height'(initial drawing area size) can be set in startup 
  program (via View->Set drawing Area). All editors will start having this 
  drawing area size.

- -maxdrawing 'width'x'height'(maximal drawing area size) can be set in startup 
  program. Editors can't have a drawing area which is larger than this maximum
  (when the workstation has too little memory it will crash on a too
   large drawing area). -maxdrawing is a new command line option.

- Set default font option. Every new cell text or text shape 
   will get that X font. When the document is printed or saved as
   PostScript, a PostScript font is chosen that resembles as much as
   possible to the the X font.

- Update font operation. Every selected cell or shape will get the
   chosen font. Of each cell or shape the font is stored in the TCM file
   in a distinct field. (NB. all texts of a complex shape have the same font).

- Default font and update font are issued in a (new) Text menu in the 
  main menu bar.

- The text fonts families currently include:
   Helvetica, Courier, Times and NewcenturySchoolbook.  
   Default: Helvetica.

- The font styles currently include: 
   Roman, Bold, Italic (Oblique) and BoldItalic (BoldOblique)
   Default: Roman

- The point sizes currently include: 
   8, 10, 12, 14, 18, 24.  
   Default: 10pt.

- Text in symbol font (for mathematical (mostly Greek) characters).

- TCM can be started up with a private color map by a command line 
  option: -priv_cmap.

- Outline editing: window has a clear button which removes all characters.

- Inline editing: cursor positioning by mouse clicking: on entering the 
  edit mode the cursor will appear after the last character. After that, 
  it can be moved to an arbitrary cursor position in the text string 
  by mouse clicking the text.

- Alignment left/center/right of a multi-line text label in the diagram editors.
  (alignments are stored in the TCM files for each shape). There is a default
  alignment (center), which can be changed. There is also an update alignment 
  command (works on current selection). Default alignment and update alignment 
  commands can be found in the Text menu.

- Annotation text of a diagram can be filled in in a pop-up edit window 
  (issued via the Diagram menu). The annotation is stored in the TCM files.


Small changes/Implementation/Bug fixes:

- Table editors: Column/Row alignment and Text margin/width menu items are
  moved from the Layout menu to the Text menu. The Layout menu is now called
  Table.

- Table editors: Default number of rows/columns command is issued via
  a slider dialog instead of a text field.

- Table editors: Line type is now called Line Style.

- Generated PostScript: default line width is a bit smaller.
  PostScript lines are now 3/4 of the default width.
  NB. in X a line is always 1 pixel wide.

- Outline editing: the edit window can now be resized to all directions and
  the edit area resizes with.

- Searching for Unix programs first starts in $TCM_HOME/bin. Alternative
  locations can now be reached via symbolic links.

- There was a bug in Move diagram in TCRD that caused a problem of 
  unconnected lines when boxes are moved that had undergone a type change, 
  like triple box->double box. This is fixed by now.

- _During_ editing you could not switch between in-line and outline
  editing. This is fixed by now.

- Rewrote startup program (tcm.c) into a new class StartupWindow
  (specialization of MainWindow), using menu, dialogmanager etc.

- Adapted DialogManager so that it does not depend anymore
  on MainWindow.

- All integer constants in header files are either made enums in 
  a class or are made class constants and the value is specified
  in the source file (not in header file). 

- All automatic resizing and layout positioning in the diagram and
  table editors now (seem to) work correctly with multiple text fonts.

- Removed bug that made tfdt crash when a diagram was loaded.

- Removed bug in the tree editors: when a diagram was loaded in tree mode
  it was displayed in edit mode (the toggle was reversed).

- File format of table editors is a bit different: first the rows are stored
  (including the cell texts) and then the columns. The line types and
  text alignments are not stored anymore as integers but as normal words
  like dashed, fat, invisible etc. The old format is still being read of
  course.

- New class XFont which encapsulates TCM fonts. It converts a TCM font to
  an equivalent X font description (XLFD) or a PostScript font description.



Version 1.21 (Jul 22 1996).
----------------------------------------

- Added 'psf' perl script + man page to exec distribution (psf offers
  several PostScript filter options).

- Rewrote part of source code to lessen the number of (C) functions
  that are not C++ class members.

- Rewrote part of source code to lessen the number of global variables
  (only 4 are left, which are only used in WindowSA).

- Different editor fonts (X and PostScript): Helvetica, Times-Roman and Courier.
  All can be used in 14, 12, 10 and 8 points. Font change via 'Font' submenu.

- Center to page operation added. Issued via a button labeled 'C' amidst
  the arrow buttons.

- Option (in page menu) to show document info as header or footer of each page. 
  These headers or footers will be printed like they are displayed (wysiwyg).

- Option (in page menu) to show page numbers. Page numbers will be printed when 
  that option is on (Page numbers displayed either at the top of the page 
  (footer is on) or at the bottom (header or none)).

- All changeable printer options now in Printer Options sub-menu in Print menu.

- Extra printer options added:
	- set print command (e.g. /usr/local/bin/lpr).
	- print extra banner page (yes/no).
	- print duplex pages (yes/no).
        - print tumbled pages (yes/no).

	The duplex and tumble options are implemented by filtering
	the PostScript output through psf. If psf can't be found a warning 
        is issued.

- Some small changes to generated PostScript and EPSF to make them apply better
  to the Adobe structuring rules.

- Information that is given in 'document info' is extended by tool and 
  file info.

- Change to file format (oldies are still being read) in which the 
  following items are renamed (Created -> CreatedOn, Written -> WrittenOn, 
  Generator->GeneratedFrom) and in the Storage clause a new field
  WrittenBy is added (login name that saved the document).

- The generator field contains the name of the tool that saved the file. 
  That name is extended by the TCM version number, e.g. TGD-version-1.21.


Version 1.20 (Jun 13 1996).
---------------------------

- Makefile and Config.tmpl for HP-UX (thanks to Hielko Ophof).

- Makefile and source code changes for compiling with HP-UX (...).

- Comments and layout of source code revised and made suitable for using 
  with DOC++.

- C++ class documentation generated automatically by DOC++. 
  Available in ./doc/classes.ps (src distribution only).

- technical documentation about the source code in ./doc/techdoc.ps 
  (src distribution only).

- CHANGELOG file added to distributions.


Version 1.19 (May 15 1996).
----------------------------

- Layout of (CRD) object class boxes improved.

- Layout of (STD) transition arrows improved.

- Possible crashes and memory leaks removed (with the program purify).

